export function useFormKitSchema() {
  const addComponent = (component = "Button", props = {}, render = "true") => {
    return {
      $cmp: component,
      if: render,
      props
    };
  };
  const addElement = (element = "div", children = [], attrs = {}, render = "true") => {
    return {
      $el: element,
      if: render,
      attrs,
      children
    };
  };
  const addGroup = (name, children = [], render = "true") => {
    return {
      $formkit: "group",
      if: render,
      name,
      children
    };
  };
  const addList = (name, children, dynamic = true, render = "true") => {
    return {
      $formkit: "list",
      if: render,
      name,
      dynamic,
      children
    };
  };
  const addListGroup = (children = [], render = "true") => {
    return {
      $formkit: "group",
      if: render,
      for: ["item", "index", "$items"],
      // 👈 $items is in the slot’s scope
      key: "$item",
      index: "$index",
      children
    };
  };
  function addListGroupFunctions(data, addNodeDefaultObject = {}) {
    const swapElements = (array, index1, index2) => {
      array[index1] = array.splice(index2, 1, array[index1])[0];
      return array;
    };
    data.addNode = (parentNode) => () => {
      const newArray = [...parentNode.value, addNodeDefaultObject];
      parentNode.input(newArray, false);
    };
    data.removeNode = (parentNode, index) => () => {
      parentNode.input(parentNode._value.filter((_, i) => i !== index), false);
    };
    data.moveNodeUp = (parentNode, index) => () => {
      const array = [...parentNode.value];
      if (index > 0)
        parentNode.input(swapElements(array, index - 1, index), false);
    };
    data.moveNodeDown = (parentNode, index) => () => {
      const array = [...parentNode.value];
      if (index < array.length - 1)
        parentNode.input(swapElements(array, index, index + 1), false);
    };
    data.copyNode = (parentNode, index) => () => {
      const obj = parentNode.value[index];
      const newArray = [...parentNode.value, { ...obj }];
      parentNode.input(newArray, false);
    };
  }
  return { addComponent, addElement, addGroup, addList, addListGroup, addListGroupFunctions };
}
